#! /bin/env python

from time import sleep
import signal, os

interrupted = False
dump_requested = False
def signal_handler(signum, frame):
    global interrupted, dump_requested
    if signum == 15 or signum == 2:
        interrupted = True
    if signum == 16:
        dump_requested = True

try:
    # Try to recover current state 
    with open('state', 'r') as file: 
        the_start = int(file.read())
except:
    # Otherwise bootstrap at 1
    the_start = 1



signal.signal(signal.SIGINT, signal_handler)
signal.signal(signal.SIGTERM, signal_handler)
signal.signal(signal.SIGUSR1, signal_handler)
the_end = 10

for i in range(the_start,the_end):
    if dump_requested or interrupted :
        # Save current state 
        with open('state', 'w') as file:
            file.write(str(i))
        dump_requested = False
    if interrupted:
        break
    # Heavy computations
    print i
    sleep(1)







