// module load gcc && gcc crsigvacount.c -o crsigvacount && ./crsigvacount

#include <stdlib.h>
#include <signal.h>
#include <stdio.h>

volatile sig_atomic_t interrupted = 0;

void catch_signal(int sig)
{
  interrupted = 1;
}



void main() 
{
  int i, the_start, the_end;
  FILE * file;  

  // Register signal handler
  signal(SIGINT, catch_signal); 

  // Try to recover current state
  file = fopen("state", "r");
  if (file) 
  {
    fscanf(file, "%d", &the_start);
    fclose(file);
  }
  else 
  {
    // Otherwise bootstrap at 1
    the_start = 1;
  }

  the_end = 10;

  for (i=the_start; i<=the_end && !interrupted;       i++)
  {
    // Heavy computations that 
    // might be interrupted
    printf("%d\n", i);
    sleep(1);
  }

  // Iterations are over or 
  // have been interrupted
  // Anyway save the state.
  file = fopen("state", "w");
  fprintf(file, "%d", i);
  fclose(file);
}








