#!/bin/bash 
#SBATCH --job-name=mytest
#SBATCH --time=2

if [ -f context.$SLURM_JOB_NAME* ]
then
  echo Checkpoint file found. Restarting
  export theprocpid=$(ls context.$SLURM_JOB_NAME*|cut -d. -f3)
  cr_restart context.$SLURM_JOB_NAME.$theprocpid &
  thewaitpid=$!
else
  echo No Checkpoint file found. Bootstraping
  cr_run ./count &
  export theprocpid=$!
  thewaitpid=$theprocpid
  echo PID=$theprocpid
fi

sleep 30
while cr_checkpoint -f context.$SLURM_JOB_NAME.$theprocpid $theprocpid 
do
  echo Checkpoint created.
  sleep 30
done &

wait $thewaitpid
