#!/bin/bash 
#SBATCH --job-name=mytest
#SBATCH --time=2
#SBATCH --signal=USR1@60

srun --overcomit watchdog.sh

if [ -f context.$SLURM_JOB_NAME* ]
then
  echo Checkpoint file found. Restarting
  export theprocpid=$(ls context.$SLURM_JOB_NAME*|cut -d. -f3)
  cr_restart context.$SLURM_JOB_NAME.$theprocpid 
  thewaitpid=$!
else
  echo No Checkpoint file found. Bootstraping
  cr_run ./count 
  export theprocpid=$!
  thewaitpid=$theprocpid
  echo PID=$theprocpid
fi

