#!/bin/sh
# Sample SLURM batch script to run a program
# Be sure to modify the XXXX to the actual number of tasks for --ntasks.
# Be sure to also modify the dmtcp_launch line for your actual job.

#SBATCH --ntasks=1
#SBATCH --time=2
#SBATCH --output=res
  
# Report actual hostname to user.
hostname

# If you install DMTCP in your user directory (not cluster-wide) you need to
# extend the PATH variable:
export PATH=./dmtcp-2.0/bin:$PATH

# Start dmtcp_coordinator (Fix if debugging or using coordinator on front end.)
srun --overcommit --ntasks=1 dmtcp_coordinator &

# DMTCP coordinator needs to be started on localhost. Or put the other host
#   in the '-h' option.
# The flag '--interval 3600' creates a checkpoint every hour (3600 seconds).
dmtcp_launch --rm --interval 30 -h `hostname` ../1-OriginalVersion/count
