#!/bin/sh
# Sample SLURM batch script for restart
# You'll also need to customize the SBATCH lines below.
# The script, ./dmtcp_restart_script.sh, will have been created for you
#   by a checkpoint during the initial run.

#SBATCH --ntasks=1
#SBATCH --output=res
#SBATCH --open-mode=append
  
# Report actual hostname to user.
hostname

# If you install DMTCP in your user directory (not cluster-wide), you'll
# need to extend PATH variable:
export PATH=./dmtcp-2.0/bin:$PATH

# Start dmtcp_coordinator (Fix if debugging or using coordinator on front end.)
srun --overcommit dmtcp_coordinator &
export DMTCP_HOST=`hostname`

# The flag '--interval 3600' creates a checkpoint every hour (3600 seconds).
./dmtcp_restart_script.sh --interval 30
