#include "uniquepid.h"
#include "../jalib/jassert.h"

// dmtcp_launch, and dmtcp_coordinator, and dmtcp_command do not
//   need to load dmtcpworker.cpp
// libdmtcpinternal.a contains code needed by dmtcpworker and the utilities
//    alike.
// libnohijack.a contains stub functions (mostly empty definitions
//   corresponding to definitions in libdmtcp.so.  It includes
//   nosyscallsreal.c and this file (dmtcpworkerstubs.cpp).
// libdmtcp.so and libsyscallsreal.a contain the wrappers and other code
//   that executes within the end user process

// libdmtcp.so defines this differently
void _dmtcp_setup_trampolines() {}

void dmtcp_event_hook(DmtcpEvent_t id, void* data)
{
  return;
}

int  dmtcp_get_ckpt_signal()
{
  JASSERT(false) .Text ("NOT REACHED");
  return -1;
}

const char* dmtcp_get_tmpdir()
{
  static dmtcp::string tmpdir;
  tmpdir = dmtcp::UniquePid::getTmpDir();
  return tmpdir.c_str();
}

const char* dmtcp_get_uniquepid_str()
{
  static dmtcp::string uniquepid_str;
  uniquepid_str = dmtcp::UniquePid::ThisProcess(true).toString();
  return uniquepid_str.c_str();
}

DmtcpUniqueProcessId dmtcp_get_uniquepid()
{
  return  dmtcp::UniquePid::ThisProcess(true).upid();
}

int  dmtcp_is_running_state()
{
  JASSERT(false);
  return 0;
  //return dmtcp::WorkerState::currentState() == dmtcp::WorkerState::RUNNING;
}

int  dmtcp_is_protected_fd(int fd)
{
  JASSERT(false);
  return 0;
}

int  dmtcp_no_coordinator()
{
  JASSERT(false);
  return 0;
}
